-- A gated D latch desribed the hard way
LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY part2a IS
	PORT ( Clk, D : IN STD_LOGIC;
				Q : OUT STD_LOGIC);
END ;

ARCHITECTURE Structural OF part2a IS
	SIGNAL S, R, R_g, S_g, Qa, Qb : STD_LOGIC ;
	ATTRIBUTE KEEP : BOOLEAN;
	ATTRIBUTE KEEP OF R, S, R_g, S_g, Qa, Qb : SIGNAL IS TRUE;
BEGIN
   R <= NOT D;
	S <= D;
	R_g <= R NAND Clk;
	S_g <= S NAND Clk;
	Qa <= S_g NAND Qb;
	Qb <= R_g NAND Qa;
	Q <= Qa;
END Structural;