LIBRARY ieee ;
USE ieee.std_logic_1164.all ;

ENTITY Reg8bit_With_Async_Reset IS
	PORT ( rst, Clk : IN STD_LOGIC ;
	      D : In std_logic_vector(7 DOWNTO 0) ;
			Q : OUT std_logic_vector(7 DOWNTO 0)) ;
END Reg8bit_With_Async_Reset ;

ARCHITECTURE Behavior OF Reg8bit_With_Async_Reset IS
BEGIN
	PROCESS (rst, Clk )
	BEGIN
	   If(rst = '1') then
			Q <= (others => '0');
		ELSIF rising_edge(Clk) THEN
			Q <= D ;
		END IF ;
	END PROCESS ; 
END Behavior ;


