LIBRARY ieee;
USE ieee.std_logic_1164.all;

ENTITY MSD_flipflop IS
	PORT ( Clk, D : IN STD_LOGIC;
				Q : OUT STD_LOGIC);
END ;

ARCHITECTURE Structural OF MSD_flipflop IS
	SIGNAL Qm, Qs, NClk : STD_LOGIC ;
	ATTRIBUTE KEEP : BOOLEAN;
	ATTRIBUTE KEEP OF Qm, Qs : SIGNAL IS TRUE;
BEGIN
NClk <= not Clk;
Dinst1: entity work.D_latch
	port map 
	(
		D => D,
		Clk => NClk,
		Q => Qm
	);
	
Dinst2: entity work.D_latch
	port map 
	(
		D => Qm,
		Clk => Clk,
		Q => Qs
	);	
	Q <= Qs;
END Structural;